# coding: utf-8

"""
    ExKoin API Documentation

    API documentation for ExKoin Crypto exchange

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class PrivateDepositsGet200ResponseInner(BaseModel):
    """
    PrivateDepositsGet200ResponseInner
    """ # noqa: E501
    id: StrictStr
    currency: StrictStr
    amount: StrictStr
    fee: StrictStr
    address_to: Optional[StrictStr] = None
    address_from: Optional[StrictStr] = None
    network: StrictStr
    memo: Optional[StrictStr] = None
    txid: Optional[StrictStr] = None
    block_height: Optional[Union[StrictFloat, StrictInt]] = None
    status: StrictStr
    timestamp: Union[StrictFloat, StrictInt]
    confirmations: Union[StrictFloat, StrictInt]
    confirmations_required: Union[StrictFloat, StrictInt]
    __properties: ClassVar[List[str]] = ["id", "currency", "amount", "fee", "address_to", "address_from", "network", "memo", "txid", "block_height", "status", "timestamp", "confirmations", "confirmations_required"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['completed', 'pending', 'failed']):
            raise ValueError("must be one of enum values ('completed', 'pending', 'failed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PrivateDepositsGet200ResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PrivateDepositsGet200ResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "currency": obj.get("currency"),
            "amount": obj.get("amount"),
            "fee": obj.get("fee"),
            "address_to": obj.get("address_to"),
            "address_from": obj.get("address_from"),
            "network": obj.get("network"),
            "memo": obj.get("memo"),
            "txid": obj.get("txid"),
            "block_height": obj.get("block_height"),
            "status": obj.get("status"),
            "timestamp": obj.get("timestamp"),
            "confirmations": obj.get("confirmations"),
            "confirmations_required": obj.get("confirmations_required")
        })
        return _obj


